#[doc = "Register `INTR_MASKED` reader"]
pub struct R(crate::R<INTR_MASKED_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<INTR_MASKED_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<INTR_MASKED_SPEC>> for R {
    fn from(reader: crate::R<INTR_MASKED_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `INTR_MASKED` writer"]
pub struct W(crate::W<INTR_MASKED_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<INTR_MASKED_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<INTR_MASKED_SPEC>> for W {
    fn from(writer: crate::W<INTR_MASKED_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `COMP0_MASKED` reader - Logical and of corresponding request and mask bits."]
pub struct COMP0_MASKED_R(crate::FieldReader<bool, bool>);
impl COMP0_MASKED_R {
    pub(crate) fn new(bits: bool) -> Self {
        COMP0_MASKED_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for COMP0_MASKED_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `COMP1_MASKED` reader - Logical and of corresponding request and mask bits."]
pub struct COMP1_MASKED_R(crate::FieldReader<bool, bool>);
impl COMP1_MASKED_R {
    pub(crate) fn new(bits: bool) -> Self {
        COMP1_MASKED_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for COMP1_MASKED_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bit 0 - Logical and of corresponding request and mask bits."]
    #[inline(always)]
    pub fn comp0_masked(&self) -> COMP0_MASKED_R {
        COMP0_MASKED_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Logical and of corresponding request and mask bits."]
    #[inline(always)]
    pub fn comp1_masked(&self) -> COMP1_MASKED_R {
        COMP1_MASKED_R::new(((self.bits >> 1) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Interrupt request masked\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [intr_masked](index.html) module"]
pub struct INTR_MASKED_SPEC;
impl crate::RegisterSpec for INTR_MASKED_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [intr_masked::R](R) reader structure"]
impl crate::Readable for INTR_MASKED_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [intr_masked::W](W) writer structure"]
impl crate::Writable for INTR_MASKED_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets INTR_MASKED to value 0"]
impl crate::Resettable for INTR_MASKED_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
